//////////////////////////////////////////////////////////////////////////////
// File: winlib/types.h
//
// $URL: https://svn.home.lan/winlib/trunk/code/libwin/src/winlib/types.h $
// $Id: types.h 33 2010-05-20 20:11:37Z jcurl $
//
// Description
//
// Design
//  This is a PRIVATE header for your program. If you make this public, you
//  have the problem that you need to make also <config.h> public. That means
//  you don't get 'bool_t' automatically (because we're trying to keep to C89)
//
// Revision History:
//
//  The revision history contains the date of a change, the author of the
//  change and in the description at a minimum the Problem Report that
//  required the change.
//
//  Date    Author   Description
//  ------- -------- ---------------------------------------------------------
//  11Jul08 jcurl    Initial Version
//
// To Do:
//
//////////////////////////////////////////////////////////////////////////////

#ifndef WINLIB_TYPES_H
#define WINLIB_TYPES_H

//////////////////////////////////////////////////////////////////////////////
// Includes
//////////////////////////////////////////////////////////////////////////////
#include <config.h>

// Standard System Includes
#ifdef __MSVCRT__
# include <windows.h>
#else
# define WINAPI
#endif

// Defining the type 'bool_t'
#ifdef HAVE_STDBOOL_H
# include <stdbool.h>
# ifndef bool_t
typedef _Bool bool_t;
# endif
#else
# ifndef true
#  define true 1
# endif
# ifndef false
#  define false 0
# endif
typedef int bool_t;
#endif
#ifndef TRUE
# define TRUE 1
#endif
#ifndef FALSE
# define FALSE 0
#endif

// Other types
#include <sys/types.h>
#ifdef HAVE_STDINT_H
#include <stdint.h>
#endif
#ifdef HAVE_INTTYPES_H
#include <inttypes.h>
#endif

// Local Libraries

//////////////////////////////////////////////////////////////////////////////
// Global Defines
//////////////////////////////////////////////////////////////////////////////
#ifndef SIZEOF_ARRAY
#define SIZEOF_ARRAY(array) (sizeof(array)/sizeof(array[0]))
#endif

#ifndef min
#define min(a,b) ((a)<(b)?(a):(b))
#endif

#ifndef max
#define max(a,b) ((a)>(b)?(a):(b))
#endif

//////////////////////////////////////////////////////////////////////////////
// Type Definitions
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
// External Objects
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
// Function Declarations
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
#endif
