# $URL: https://svn.home.lan/winlib/trunk/code/m4/progid.m4 $
# $Id: progid.m4 23 2009-09-20 16:33:04Z jcurl $

# LX_PROG_ID_CURRENT_USER
# -----------------------
# Looks for the program 'id' and checks that it works and that it understands
# the option '-un'.
#
# If found,
#  - ac_cv_prog_id=yes
#  - ID=/path/to/id/program
#  - IDFLAGS=-x
# If not found,
#  - ac_cv_prog_id=no
AC_DEFUN([LX_TEST_ID],
  [if test x$ac_cv_prog_id != xyes; then
      uname=`$1 $2 2> /dev/null`
      if test -z $uname; then
         ac_cv_prog_id=no
      else
         ac_cv_prog_id=yes
         ID=`echo $1`
         IDFLAGS=`echo $2`
      fi
   fi
  ])

AC_DEFUN([LX_PROG_ID_CURRENT_USER],
  [AC_MSG_CHECKING([for id])
   # Check if the user provided the variable ID
   if test x$ID != x; then
      LX_TEST_ID([$ID],[$IDFLAGS])
   fi

   case "$host_os" in
      solaris2.*)
         # Check if we're running Solaris
         LX_TEST_ID([/usr/xpg4/bin/id],[-un])
         ;;
      *)
         ;;
   esac

   # Check the default
   LX_TEST_ID([id],[-un])

   # Show the updates
   if test x$ac_cv_prog_id = xyes; then
      AC_MSG_RESULT([$ID $IDFLAGS])
      AC_SUBST(ID)
      AC_SUBST(IDFLAGS)
   else
      AC_MSG_RESULT([Not found])
   fi
  ])
