# $URL: https://svn.home.lan/winlib/trunk/code/m4/stdint.m4 $
# $Id: stdint.m4 32 2010-05-20 12:20:37Z jcurl $

# LX_HEADER_STDINT
# ----------------
# Searches for the header file <stdint.h>. If it is found, it is checked for
# the definition of the following entries:
#
#  uint8_t, uint16_t, uint32_t, int8_t, int16_t, int32_t
#
# If they don't exist, the sizes of standard types are checked, and defines
# are made to try and emulate what normally is in <stdint.h>

AC_DEFUN([LX_HEADER_STDINT],
  [AC_CHECK_SIZEOF(char)
   AC_CHECK_SIZEOF(short)
   AC_CHECK_SIZEOF(int)
   AC_CHECK_SIZEOF(long)
   AC_CHECK_SIZEOF(long long)
   AC_CHECK_SIZEOF(void *)
   AC_TYPE_INT8_T
   AC_TYPE_INT16_T
   AC_TYPE_INT32_T
   AC_TYPE_INT64_T
   AC_TYPE_UINT8_T
   AC_TYPE_UINT16_T
   AC_TYPE_UINT32_T
   AC_TYPE_UINT64_T

   # Now define stuff we want in our config header. We check against no
   # as this is the definitive that we have it. Not being yes doesn't mean
   # we don't have it.
   if test "x$ac_cv_c_uint64_t" != "xno"; then
     AC_DEFINE(HAVE_UINT64_T, 1, [Define if we can use the uint64_t type])
   fi
   if test x$ac_cv_c_int64_t != xno; then
     AC_DEFINE(HAVE_INT64_T, 1, [Define if we can use the int64_tq type])
   fi
  ])

